import { pipe } from './pipe';
import { filter } from './filter';
import { createCounter } from './_counter';
describe('data_first', function () {
    it('filter', function () {
        var result = filter([1, 2, 3], function (x) { return x % 2 === 1; });
        expect(result).toEqual([1, 3]);
    });
    it('filter.indexed', function () {
        var result = filter.indexed([1, 2, 3], function (x, i) { return x % 2 === 1 && i !== 1; });
        expect(result).toEqual([1, 3]);
    });
});
describe('data_last', function () {
    it('filter', function () {
        var counter = createCounter();
        var result = pipe([1, 2, 3], filter(function (x) { return x % 2 === 1; }), counter.fn());
        expect(counter.count).toHaveBeenCalledTimes(2);
        expect(result).toEqual([1, 3]);
    });
    it('filter.indexed', function () {
        var counter = createCounter();
        var result = pipe([1, 2, 3], filter.indexed(function (x, i) { return x % 2 === 1 && i !== 1; }), counter.fn());
        expect(counter.count).toHaveBeenCalledTimes(2);
        expect(result).toEqual([1, 3]);
    });
});
